<?php
/*
 * Our model file.
 *
 * PHP version 5
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the Affero General Public License as published by Affero Inc.,
 * either version 1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful to the Free
 * Software community, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the Affero
 * General Public License for more details.
 * 
 * You should have received a copy of the Affero General Public License with this
 * software in the ./AfferoGPL file; if not, write to Affero Inc., 510 Third Street,
 * Suite 225, San Francisco, CA 94107, USA
 *
 * @category   Model Class
 * @author     Klaus Weiss <klaus.weiss@nanet.at>
 * @copyright  2007 GNU Herds Free Software Association
 * @license    http://www.affero.org/oagpl.html Affero GPL
 * @version    CVS: $Id:$
 * @since      File available since version 1.5
 */

if(!defined('VISIBLE')) exit();

class DB
{
  private $db = null;

  public function __construct()
  {
    try
      {
	$this->db = new PDO('mysql:host='.DB_HOST.';dbname='.DB_NAME,
			    DB_USER, DB_PASSWD,
			    array(PDO::ATTR_PERSISTENT => DB_PERSIST));
      }
    catch(PDOException $e)
      {
	show_error_site('PDO Error', $e->getMessage());
      }
  }

  public function validate()
  {
  }


  public function query($sql)
  {
    if(DB_DEBUG)
      {
	show_debug_message('DB Debug', $sql);
      }
  }
}

?>