<?php
/*
 * Our html helper file.
 *
 * PHP version 5
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the Affero General Public License as published by Affero Inc.,
 * either version 1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful to the Free
 * Software community, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the Affero
 * General Public License for more details.
 * 
 * You should have received a copy of the Affero General Public License with this
 * software in the ./AfferoGPL file; if not, write to Affero Inc., 510 Third Street,
 * Suite 225, San Francisco, CA 94107, USA
 *
 * @category   Html Helper Class
 * @author     Klaus Weiss <klaus.weiss@nanet.at>
 * @copyright  2007 GNU Herds Free Software Association
 * @license    http://www.affero.org/oagpl.html Affero GPL
 * @version    CVS: $Id:$
 * @since      File available since version 1.5
 */

if(!defined('VISIBLE')) exit();

class Html
{
  public $view = null;

  public $elementId = 0;


  public function __construct($view)
  {
    $this->view = $view;
  }

  public static function link($title, $url = null)
  {
    if(is_array($url))
      {
	$cntr = $url['cntr'];
	$action = $url['action'];
	$params = $url['params'];
      }
    else
      {
	$array = split('/', $url);

	$cntr = $array[1];
	$action = $array[2];
	$params = $array[3];
      }

	return '<a href="'.SITE_URL.'/index.php/'.$cntr.'/'.$action.$params.'">'.$title.'</a>';
  }

  public function formStart($action, $name = null, $method = 'post')
  {
    if(!$name)
      {
	return '<form name="f'.$this->elementId++.'" method="'.$method.'" action="'.$action.'">';
      }
    else
      {
	return '<form name="'.$name.'" method="'.$method.'" action="'.$action.'">';
      }
  }

  public function input($model, $attributes = null)
  {
    if(!$attributes)
      {
	return '<input type="text" name="'.$model.'" id="'.$this->elementId++.'">';
      }
    else
      {
        $s_input = '<input ';

	if(isset($this->view->cntr->triggeredFormErrors[$model]) and
	   isset($this->view->triggeredFormErrors[$model]))
	  {
	    $s_value = 'value="'.$this->view->triggeredFormErrors[$model].'" ';
	  }

	if(isset($attributes['value']) and !isset($s_value))
	  {
	    $s_input .= 'value="'.$attributes['value'].'"';
	  }
	else if(isset($s_value))
	  {
	    $s_input .= $s_value;
	  }


	if(isset($attributes['type']))
	  {
	    $s_input .= 'type="'.$attributes['type'].'" ';
	  }
	else
	  {
	    $s_input .= 'type="text" ';
	  }

	$s_input .= 'name="'.$model.'" ';

	if(isset($attributes['size']))
	  {
	    $s_input .= 'size="'.$attributes['size'].'" ';
	  }

	if(isset($attributes['class']))
	  {
	    $s_input .= 'class="'.$attributes['class'].'" ';
	  }

	if(isset($attributes['id']))
	  {
	    $s_input .= 'id="'.$attributes['id'].'" ';
	  }
	else
	  {
	    $s_input .= 'id="'.$this->elementId++.'" ';
	  }

	$s_input .= '>';

	return $s_input;
      }
  }

  public function submit($value, $name = null)
  {
    if(!$name)
      {
	return '<input type="submit" value="'.$value.'">';
      }
    else
      {
	return '<input type="submit" name="'.$name.'" value="'.$value.'">';
      }
  }

  public function formEnd()
  { 
    return '</form>';
  }
}


?>