<?php
/*
 * Our lowlevel function library.
 *
 * PHP version 5
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the Affero General Public License as published by Affero Inc.,
 * either version 1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful to the Free
 * Software community, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the Affero
 * General Public License for more details.
 * 
 * You should have received a copy of the Affero General Public License with this
 * software in the ./AfferoGPL file; if not, write to Affero Inc., 510 Third Street,
 * Suite 225, San Francisco, CA 94107, USA
 *
 * @category   Dependency
 * @author     Klaus Weiss <klaus.weiss@nanet.at>
 * @copyright  2007 GNU Herds Free Software Association
 * @license    http://www.affero.org/oagpl.html Affero GPL
 * @version    CVS: $Id:$
 * @since      File available since version 1.5
 */

if(!defined('VISIBLE')) exit();

define('ERROR_NO_CONTROLLER', 1);
define('ERROR_NO_ACTION', 2);
define('ERROR_NO_VIEW', 3);
define('ERROR_NO_MODEL', 4);

function show_error_site($id, $content = '')
{
  $errorpath = ROOT.'/../../site/view/errors/';

  switch($id)
    {
    case ERROR_NO_CONTROLLER:
      require_once($errorpath.'nocontroller.html');
      break;

    case ERROR_NO_ACTION:
      require_once($errorpath.'noaction.html');
      break;

    case ERROR_NO_VIEW:
      require_once($errorpath.'noview.html');

    case ERROR_NO_MODEL:
      require_once($errorpath.'nomodel.html');
    }

  exit();
}

function show_debug_message($title, $body)
{
  printf('<strong>%s</strong>', $title);
  printf('<p>%s</p>', $body);
  echo '<hr/>';
}

function is_model($model)
{
  $model_file = ROOT.'/../../site/model/'.$model.'.php';

  if(!file_exists($model_file))
    {
      return false;
    }

  require_once($model_file);

  if(!class_exists($model))
    {
      return false;
    }

  return true;
}

?>